import React, {useRef, useState} from 'react';
import {Input, message, Modal} from 'antd';
import {useDispatch, useSelector} from "react-redux";
import {newDir} from "../../../utils/File";
import {dirDirAdd} from "../../../redux/dirMessage_reducer";
import {isEmpty} from "../../../utils/ObjectUtils";
import {fileDirFormat} from "../../../utils/PathOperate";

const DirAddDir = (prop) => {
    console.log("prop",prop)
    const [isModalOpen, setIsModalOpen] = useState(false);
    const dispatch = useDispatch();
    const inputValue = useRef(null);
    const [messageApi, contextHolder] = message.useMessage();

    const showModal = () => {
        setIsModalOpen(true);
    };
    const handleOk = () => {
        console.log("inputValue",inputValue.current.input.value)
        // 如果为空则提示
        if (isEmpty(inputValue.current.input.value)){
            let messageType = messageApi.open({
                type: 'error',
                content: '文件夹名不能为空',
            });
            return
        }
        // 新建文件
        let fileName = inputValue.current.input.value;
        let filePath = fileDirFormat(prop.fileDir,fileName)
        console.log("DirAddDir-filePath",filePath)
        newDir(filePath)
        // 更新树
        dispatch(dirDirAdd({"filePath":filePath,"fileDir":prop.fileDir,fileName}))
        setIsModalOpen(false);
    };
    const handleCancel = () => {
        setIsModalOpen(false);
    };
    return <>
        {contextHolder}
        <a className="menuItemClick" onClick={showModal}>添加文件夹</a>
        <Modal title="新建文件夹" open={isModalOpen} onOk={handleOk} onCancel={handleCancel}>
            <Input ref={inputValue} placeholder="文件夹名不能为空" />
        </Modal>
    </>;
};
export default DirAddDir;
